(define (domain minecraft-house)
	(:requirements :typing :negative-preconditions :existential-preconditions :universal-preconditions )
	(:types  location type building - object
			blocktype direction number - type
			wall - building)
	(:predicates (empty ?loc - location)
		(block-at ?loc - location ?type - blocktype)
		(neighbour ?loc1 ?loc2 - location ?dir - direction) 
		(on-top ?loc1 ?loc2 - location) 
		(rest-row ?loc - location ?len - number ?dir - direction ?t - blocktype)
		(wall-at ?w - wall ?loc - location ?dir - direction)
		(wall-initial ?w - wall ?loc - location)
		(current-wall-loc ?w - wall ?loc - location)
		(wall-height ?w - wall ?height - number)
		(wall-length ?w - wall ?length - number)
		(wall-dir ?w - wall ?dir - direction)
		(wall-type ?w - wall ?t - blocktype)
		(building-row)
		(current-wall ?w - wall)
		(prev ?num1 ?num2 - number)
		(is-zero ?num - number)
		(is-one ?num - number)
		(build-roof)
		(constructing-wall)
		(roof-width ?num - number)
		(roof-length ?num - number)
		(roof-dir ?dir - direction)
		(roof-btype ?t - blocktype)
		(roof-initial ?loc - location)
		(roof-dir-row ?dir - direction)
		(roof-loc ?loc - location)
		(roof-built ?loc - location)
		)


	(:action place-block
	  :parameters (?loc1 ?loc2 - location ?t - blocktype)
	  :precondition (and (empty ?loc1) (not (empty ?loc2)) (or (on-top ?loc1 ?loc2) (on-top ?loc2 ?loc1) (exists (?dir - direction) (and (neighbour ?loc1 ?loc2 ?dir)))) )
	  :effect (and (not (empty ?loc1)) (block-at ?loc1 ?t)) )

	(:action remove-block
	  :parameters (?loc - location ?t - blocktype)
	  :precondition (and (not (empty ?loc)) (block-at ?loc ?t) )
	  :effect (and (empty ?loc) (not (block-at ?loc ?t))) )

	(:action place-block-in-row
	  :parameters (?loc ?locN ?locF - location ?len ?next-len - number ?dir - direction ?t - blocktype)
	  :precondition (and (building-row) (rest-row ?loc ?len ?dir ?t) (empty ?loc) (neighbour ?loc ?locN ?dir) (prev ?len ?next-len) (not (empty ?locF)) (or (on-top ?loc ?locF) (on-top ?locF ?loc) (exists (?dir2 - direction) (and (neighbour ?loc ?locF ?dir2)) )) )
	  :effect (and (block-at ?loc ?t) (rest-row ?locN ?next-len ?dir ?t) (not (rest-row ?loc ?len ?dir ?t)) (not (empty ?loc))) )

	(:action decrease-row-length
	  :parameters (?loc ?locN - location ?len ?next-len - number ?dir - direction ?t - blocktype)
	  :precondition (and (building-row) (rest-row ?loc ?len ?dir ?t) (block-at ?loc ?t) (prev ?len ?next-len) (neighbour ?loc ?locN ?dir))
	  :effect (and (rest-row ?locN ?next-len ?dir ?t) (not (rest-row ?loc ?len ?dir ?t))))

	(:action end-row
	  :parameters (?loc ?locF - location ?len - number ?dir - direction ?t - blocktype)
	  :precondition (and (building-row) (rest-row ?loc ?len ?dir ?t) (is-one ?len) (or (block-at ?loc ?t) (and(empty ?loc) (not (empty ?locF)) (or (on-top ?loc ?locF) (on-top ?locF ?loc) (exists (?dir2 - direction) (and (neighbour ?loc ?locF ?dir2)) ) )) ))
	  :effect (and (block-at ?loc ?t) (not (empty ?loc)) (not(building-row)) (not (rest-row ?loc ?len ?dir ?t))) )

	
	(:action build-row-in-wall
	  :parameters (?w - wall ?loc ?locN - location ?len ?height ?heightN - number ?dir - direction ?t - blocktype)
	  :precondition (and (current-wall ?w) (wall-dir ?w ?dir) (wall-length ?w ?len) (wall-height ?w ?height) (wall-type ?w ?t) (current-wall-loc ?w ?loc) (prev ?height ?heightN) (on-top ?loc ?locN) (not(building-row)))
	  :effect (and (current-wall-loc ?w ?locN) (wall-height ?w ?heightN) (not (current-wall-loc ?w ?loc)) (not (wall-height ?w ?height)) (building-row) (rest-row ?loc ?len ?dir ?t)) )

	(:action begin-wall
	  :parameters (?w - wall)
	  :precondition (and (not (build-roof)) (not(constructing-wall)) )
	  :effect (and (current-wall ?w) (constructing-wall)))

	(:action finish-wall
	  :parameters (?w - wall ?loc - location ?height - number ?dir - direction)
	  :precondition (and (current-wall ?w) (is-zero ?height) (wall-height ?w ?height) (wall-dir ?w ?dir) (wall-initial ?w ?loc) (not(building-row))) 
	  :effect (and (wall-at ?w ?loc ?dir) (not (constructing-wall)) (not (current-wall ?w))) )

	(:action begin-roof
	  :parameters ()
	  :precondition (and (not (constructing-wall)))
	  :effect (and (build-roof) ))

	(:action build-row-in-roof
	  :parameters (?loc ?locN - location ?width ?widthN ?length - number ?dir ?dir2 - direction ?t - blocktype)
	  :precondition (and (build-roof) (roof-loc ?loc) (roof-width ?width) (roof-length ?length) (roof-dir ?dir2) (roof-dir-row ?dir) (roof-btype ?t) (prev ?width ?widthN) (neighbour ?loc ?locN ?dir2) (not (building-row)))
	  :effect (and (building-row) (rest-row ?loc ?length ?dir ?t) (roof-width ?widthN) (roof-loc ?locN) (not (roof-loc ?loc)) (not (roof-width ?width))))

	(:action finish-roof
	  :parameters (?loc - location ?width ?length - number)
	  :precondition (and (build-roof) (roof-initial ?loc) (roof-width ?width) (is-zero ?width) (roof-length ?length) (not(building-row)))
	  :effect (and (roof-built ?loc) (not(build-roof))))
)